#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "getopt.h"
#include "cmdline.h"
#include "version.h"

static struct option long_options[] = 
	{
		{"help",0,0,'h'},
		{"file",1,0,'f'},
		{"volthreshold",1,0,'v'},
		{"intervaltime",1,0,'t'},
		{0,0,0,0}
	};

char *cmdline(int argc, char *argv[], int *volthreshold, int *intervaltime)
{
int c=0;
int option_index = 0;
char *file=NULL;

*volthreshold = 500;
*intervaltime = 2;

while (c!=EOF)
{
c = getopt_long(argc,argv,"hv:t:f:",long_options,&option_index);

switch(c)
	{
	case 0:
	fprintf(stderr,"option %s",long_options[option_index].name);
	if (optarg)
	fprintf(stderr," with arg %d",(int)optarg);
	fprintf(stderr,"\n");
	break;

	case 'h':
	fprintf(stderr,"tape2mp3-%s -- Copyright Toby Jaffey 2000", VERSION);
	fprintf(stderr,"\nBug reports to toby@earth.li");
	fprintf(stderr,"\n\nUsage: tape2mp3 -i <file.wav>");
	fprintf(stderr,"\noptions:");	
	fprintf(stderr,"\n-h\t\t--help\tthis help");
	fprintf(stderr,"\n-f file\t\t--file\twav file to split");
	fprintf(stderr,"\n-v <0-65535>\t--volthreshold\tmaximum volume of fuzz (default 500)");
	fprintf(stderr,"\n-t <2-65535>\t--intervaltime\tminimum length of inter-track pauses in seconds (default 2)");
	fprintf(stderr,"\n\n");
	exit(-1);
	break;
	
	case 'v':
	if (sscanf(optarg,"%d", volthreshold) < 1 )
		{
		fprintf(stderr,"\nInvalid volume threshold (%s)\n",optarg);
		exit(-1);
		}
	break;

	case 't':
	if (sscanf(optarg,"%d", intervaltime) < 1 || *intervaltime < 2)
		{
		fprintf(stderr,"\nInvalid inter-track interval (%s)\n",optarg);
		exit(-1);
		}
	break;
	
	
	case 'f':
	file = strdup(optarg);
	break;
	
	case 63: // ARGGGGGGGGGHHHHHHHHHHHHhh WHY GOD WHY???
	exit(-2);
	break;
	} // end switch c
} // end while
if (file==NULL)
	{
	fprintf(stderr, "\nNo file specified, try --help\n\n");
	exit(1);
	}
return file;
} // end parse command line params
